diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/include/config.h ircd-hybrid-6.0/include/config.h
--- ircd-hybrid-6.0.orig/include/config.h	Sun Jun 24 19:46:58 2001
+++ ircd-hybrid-6.0/include/config.h	Sun Jun 24 19:45:29 2001
@@ -1131,7 +1131,7 @@
  * three different servers must do the identical GLINE in order
  * for the G line to take effect.
  */
-#define GLINES
+#undef GLINES
 #define GLINEFILE       "log/gline.log"
 
 /* GLINE_TIME - local expire time for GLINES
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/include/msg.h ircd-hybrid-6.0/include/msg.h
--- ircd-hybrid-6.0.orig/include/msg.h	Sun Jun 24 19:46:58 2001
+++ ircd-hybrid-6.0/include/msg.h	Sun Jun 24 19:45:29 2001
@@ -124,7 +124,7 @@
 #define MSG_SET      "SET"      /* SET */
 #define MSG_SILENCE  "SILENCE"  /* SILENCE */
 
-#define MSG_GLINE    "GLINE"    /* GLINE */
+/*#define MSG_GLINE    "GLINE"   */ /* GLINE */ /* We are using propagating K:lines instead */
 
 #define MSG_SETHOST  "SETHOST"  /* SETHOST */
 #define MSG_SETIDENT "SETIDENT" /* SETIDENT */
@@ -273,7 +273,7 @@
   { MSG_KLINE,   m_kline,    0, MAXPARA, 1, 0, 0, 0L },
   { MSG_UNKLINE, m_unkline,  0, MAXPARA, 1, 0, 0, 0L },
   { MSG_DLINE,   m_dline,    0, MAXPARA, 1, 0, 0, 0L },
-  { MSG_GLINE,   m_gline,    0, MAXPARA, 1, 0, 0, 0L },
+  /*  { MSG_GLINE,   m_gline,    0, MAXPARA, 1, 0, 0, 0L }, */ 
   { MSG_HASH,    m_hash,     0, MAXPARA, 1, 0, 0, 0L },
   { MSG_DNS,     m_dns,      0, MAXPARA, 1, 0, 0, 0L },
   { MSG_REHASH,  m_rehash,   0, MAXPARA, 1, 0, 0, 0L },
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/include/patchlevel.h ircd-hybrid-6.0/include/patchlevel.h
--- ircd-hybrid-6.0.orig/include/patchlevel.h	Sun Jun 24 19:46:54 2001
+++ ircd-hybrid-6.0/include/patchlevel.h	Sun Jun 24 19:45:29 2001
@@ -17,5 +17,5 @@
  */
 
 #ifndef PATCHLEVEL
-#define PATCHLEVEL    "2.8/dancer-hybrid-6.0"
+#define PATCHLEVEL    "dancer-ircd-0.9.1"
 #endif
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_kill.c ircd-hybrid-6.0/src/m_kill.c
--- ircd-hybrid-6.0.orig/src/m_kill.c	Sun Jun 24 19:46:59 2001
+++ ircd-hybrid-6.0/src/m_kill.c	Sun Jun 24 19:45:29 2001
@@ -162,7 +162,7 @@
 
   if (MyConnect(sptr) && !MyConnect(acptr) && !IsSetOperGlobalKill(sptr))
     {
-      sendto_one(sptr, ":%s NOTICE %s :Nick %s isnt on your server",
+      sendto_one(sptr, ":%s NOTICE %s :Nick %s isnt on your server, and you have no +G umode",
                  me.name, parv[0], acptr->name);
       return 0;
     }
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_kline.c ircd-hybrid-6.0/src/m_kline.c
--- ircd-hybrid-6.0.orig/src/m_kline.c	Sun Jun 24 19:46:58 2001
+++ ircd-hybrid-6.0/src/m_kline.c	Sun Jun 24 19:45:29 2001
@@ -425,7 +425,7 @@
     {
       if (!MyClient(sptr) || !IsSetOperK(sptr))
         {
-	  if (!SeesOperMessages(sptr))
+	  if (SeesOperMessages(sptr))
 	    sendto_one(sptr,":%s NOTICE %s :You have no K umode",me.name,parv[0]);
 	  else
 	    sendto_one(sptr, form_str(ERR_NOPRIVILEGES), me.name, parv[0]);
@@ -1021,7 +1021,7 @@
 
   if (!MyClient(sptr) || !IsSetOperK(sptr))
     {
-      if (!SeesOperMessages(sptr))
+      if (SeesOperMessages(sptr))
 	sendto_one(sptr,":%s NOTICE %s :You have no K umode",me.name,parv[0]);
       else
 	sendto_one(sptr, form_str(ERR_NOPRIVILEGES), me.name, parv[0]);
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/s_user.c ircd-hybrid-6.0/src/s_user.c
--- ircd-hybrid-6.0.orig/src/s_user.c	Sun Jun 24 19:46:59 2001
+++ ircd-hybrid-6.0/src/s_user.c	Sun Jun 24 19:46:34 2001
@@ -2136,7 +2136,7 @@
 	    what = MODE_DEL;
 	    break;        
 
-	  case 'O': case 'o' :
+	    /*case 'O': */case 'o' :
 	    if(what == MODE_ADD)
 	      {
 		/* I'm going to disable this for now, we do things differently
@@ -2182,8 +2182,13 @@
 
 		Count.oper--;
 
-		CopyUmodes(acptr->allowed_umodes, user_umodes);
-		AndUmodes(acptr->umodes, acptr->umodes, acptr->allowed_umodes);
+		{
+		  int identified = TestBit(acptr->umodes, UMODE_IDENTIFIED);
+		  CopyUmodes(acptr->allowed_umodes, user_umodes);
+		  AndUmodes(acptr->umodes, acptr->umodes, acptr->allowed_umodes);
+		  if (identified)
+		    SetBit(acptr->umodes, UMODE_IDENTIFIED);
+		}
 
 		if (MyConnect(acptr))
 		  {
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/version.c.SH ircd-hybrid-6.0/src/version.c.SH
--- ircd-hybrid-6.0.orig/src/version.c.SH	Sun Jun 24 19:46:58 2001
+++ ircd-hybrid-6.0/src/version.c.SH	Sun Jun 24 19:45:29 2001
@@ -62,15 +62,15 @@
 char *infotext[] =
 {
   "$package --",
-  "Based on the original code written by Jarkko Oikarinen",
+  "(Distantly) based on the original code written by Jarkko Oikarinen",
   "Copyright 1988, 1989, 1990, 1991 University of Oulu, Computing Center",
   "",
   "This program is free software; you can redistribute it and/or",
   "modify it under the terms of the GNU General Public License as",
-  "published by the Free Software Foundation; either version 1, or",
+  "published by the Free Software Foundation; either version 2, or",
   "(at your option) any later version.",
   "",
-  "The core Hybrid Team as of this major release:",
+  "Many thanks to the developers of hybrid, including:",
   "",
   "cosine              Patrick Alken       wnder@uwns.underworld.net",
   "Dianora             Diane Bruce         db@db.net",
@@ -80,48 +80,14 @@
   "Rodder              Jon Lusky           lusky@blown.net",
   "Wohali              Joan Touzet         jolo@cadence.com",
   "",
-  "The following people have contributed to this release of hybrid",
-  "in nick alphabetical order:",
-  "",
-  "Bleep               Thomas Helvey       tomh@inxpress.net",
-  "CBongo              Chris Bongaarts     cab@tc.umn.edu",
-  "comstud             Chris Behrens       cbehrens@concentric.net",
-  "echo                Adam J. Durana      adam@caca.com",
-  "FlashMan            Craig A. Huegen     chuegen@quadrunner.com",
-  "jailbird            Dustin Marquess     jailbird@alcatraz.fdf.net",
-  "johan               Johannes Erdfelt    jerdfelt@eng.mindspring.net",
-  "LarZ                Matthew Ramsey      mjr@blackened.com",
-  "orabidoo            Roger Espel Llima   espel@unix.bigots.org",
-  "Seaner              Sean McVeigh        sdlmcvei@uwaterloo.ca",
-  "Shadowfax           Michael Pearce      mpearce@varner.com",
-  "Slowaris            Ryan Parker         rjp@wpmedia.com",
-  "ThemBones           Brian Kraemer       kraemer@u.washington.edu",
-  "White_Dragon        Chip Norkus         wd@dal.net",
-  "WintrHawk           Jake Khuon          khuon@GCtr.Net",
-  "",
-  "",
-  "Developers and Contributors for previous versions:",
-  "",
-  "Chris Portman       Keith Fralick       Jon Mischo",
-  "Sam Noble           Taner Halicioglu    Darren Reed",
-  "Markku Savela       Greg Lindahl        Jarkko Oikarinen",
-  "Armin Gruner        Matthew Green       Chuck Kane",
-  "Matt Lyle           Vesa Ruokonen       Nicolas PIOCH",
-  "Stellan Klebom      Dan Goodwin         Mike Bolotski",
-  "Ian Frechette       Markku Jarvinen     Kimmo Suominen",
-  "Jeff Trim           Vijay Subramaniam   Karl Kleinpaste",
-  "Bill Wisner         Tom Davis           Hugo Calendar",
-  "Tom Hopkins         Stephen van den Berg",
-  "Bo Adler            Michael Sandrof     Jon Solomon",
-  "Jan Peterson        Helen Rose          Paul Graham",
-  "",
   "Thanks also goes to those persons not mentioned here who have added",
   "their advice, opinions, and code to IRC.",
-  "Thanks also to those who provide the kind sys admins who let me and",
-  "others continue to develop IRC.",
   "-------------------------------------------------------------------",
-  "The dancer-hybrid conversion has been arranged, orchestrated, and",
+  "",
+  "The dancer server is largely based on hybrid, and has been arranged and",
   "generally slaughtered by the following nefarious individuals:",
+  "",
+  "dent! Put names here!",
   "",
   "Comments and bug reports to opn-coders@vc.bc.ca",
   "",