diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/include/patchlevel.h ircd-hybrid-6.0/include/patchlevel.h
--- ircd-hybrid-6.0.orig/include/patchlevel.h	Mon Jun 25 08:56:44 2001
+++ ircd-hybrid-6.0/include/patchlevel.h	Mon Jun 25 08:56:26 2001
@@ -17,5 +17,5 @@
  */
 
 #ifndef PATCHLEVEL
-#define PATCHLEVEL    "dancer-ircd-0.9.1.2"
+#define PATCHLEVEL    "dancer-ircd-0.9.1.3"
 #endif
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/include/serno.h ircd-hybrid-6.0/include/serno.h
--- ircd-hybrid-6.0.orig/include/serno.h	Thu Jan  4 03:31:11 2001
+++ ircd-hybrid-6.0/include/serno.h	Mon Jun 25 08:56:19 2001
@@ -1 +1 @@
-#define SERIALNUM "20010103_2"
+#define SERIALNUM "20010625_3"
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/flud.c ircd-hybrid-6.0/src/flud.c
--- ircd-hybrid-6.0.orig/src/flud.c	Mon Jun 25 08:56:43 2001
+++ ircd-hybrid-6.0/src/flud.c	Mon Jun 25 08:45:21 2001
@@ -428,7 +428,7 @@
       sendto_ops_flag(UMODE_SKILL, "Flood countermeasure, dumping user %s",
 			     fluder->name);
       sendto_one(fluder, ":%s KILL %s :%s spam",
-                 me.name, fluder->name, cptr->name);
+                 me.name, fluder->name, cptr ? cptr->name : chptr->chname);
       exit_client(fluder, fluder, &me, "Excessive spam");
     }
 #endif
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_connect.c ircd-hybrid-6.0/src/m_connect.c
--- ircd-hybrid-6.0.orig/src/m_connect.c	Mon Jun 25 08:56:44 2001
+++ ircd-hybrid-6.0/src/m_connect.c	Mon Jun 25 08:54:35 2001
@@ -200,11 +200,23 @@
    */
   if (connect_server(aconf, sptr, 0))
 #ifdef SERVERHIDE
-    sendto_one(sptr, ":%s NOTICE %s :*** Connecting to %s[%s].%d",
-               me.name, parv[0], "255.255.255.255", aconf->name, aconf->port);
+    {
+      if (!IsSetOperAuspex(sptr))
+	sendto_one(sptr, ":%s NOTICE %s :*** Connecting to %s[%s].%d",
+		   me.name, parv[0], "255.255.255.255", aconf->name, aconf->port);
+      else
+	sendto_one(sptr, ":%s NOTICE %s :*** Connecting to %s[%s].%d",
+		   me.name, parv[0], aconf->host, aconf->name, aconf->port);
+    }
   else
-    sendto_one(sptr, ":%s NOTICE %s :*** Couldn't connect to %s.%d",
-               me.name, parv[0], "255.255.255.255",aconf->port);
+    {
+      if (!IsSetOperAuspex(sptr))
+	sendto_one(sptr, ":%s NOTICE %s :*** Couldn't connect to %s.%d",
+		   me.name, parv[0], "255.255.255.255",aconf->port);
+      else
+	sendto_one(sptr, ":%s NOTICE %s :*** Couldn't connect to %s.%d",
+		   me.name, parv[0], aconf->host,aconf->port);
+    }
 #else
     sendto_one(sptr, ":%s NOTICE %s :*** Connecting to %s[%s].%d",
                me.name, parv[0], aconf->host, aconf->name, aconf->port);
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_map.c ircd-hybrid-6.0/src/m_map.c
--- ircd-hybrid-6.0.orig/src/m_map.c	Mon Jun 25 08:56:44 2001
+++ ircd-hybrid-6.0/src/m_map.c	Mon Jun 25 07:57:57 2001
@@ -127,6 +127,8 @@
 	  {
 	    if (conf->status != CONF_NOCONNECT_SERVER)
 	      continue;
+	    if (strcmp(conf->name, me.name) == 0)
+	      continue;
 	    if (conf->map_done)
 	      {
 		conf->map_done = 0; /* clear it for the next map */
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_version.c ircd-hybrid-6.0/src/m_version.c
--- ircd-hybrid-6.0.orig/src/m_version.c	Mon Jun 25 08:56:43 2001
+++ ircd-hybrid-6.0/src/m_version.c	Mon Jun 25 06:06:44 2001
@@ -29,6 +29,8 @@
 #include "s_serv.h"
 #include "send.h"
 
+#include <string.h>
+
 /*
  * m_functions execute protocol messages on this server:
  *
@@ -95,8 +97,14 @@
 {
   if (IsSetOperRemote(sptr))
      {
-       if (hunt_server(cptr, sptr, ":%s VERSION :%s", 
-                       1, parc, parv) == HUNTED_ISME)
+       if ((parc > 0) && (strcmp(parv[1], "*") == 0))
+	 {
+	   sendto_serv_butone(cptr, ":%s VERSION :*", sptr->name);
+	   sendto_one(sptr, form_str(RPL_VERSION), me.name,
+		      parv[0], version, serno, debugmode, me.name, serveropts);
+	 }
+       else if (hunt_server(cptr, sptr, ":%s VERSION :%s", 
+			    1, parc, parv) == HUNTED_ISME)
          sendto_one(sptr, form_str(RPL_VERSION), me.name,
                     parv[0], version, serno, debugmode, me.name, serveropts);
      }