diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/include/ircd_defs.h ircd-hybrid-6.0/include/ircd_defs.h
--- ircd-hybrid-6.0.orig/include/ircd_defs.h	Wed Jun 27 20:51:03 2001
+++ ircd-hybrid-6.0/include/ircd_defs.h	Tue Jun 26 21:20:22 2001
@@ -48,7 +48,7 @@
 #define KEYLEN          23
 #define BUFSIZE         512     /* WARNING: *DONT* CHANGE THIS!!!! */
 #define MAXRECIPIENTS   20
-#define MAXBANS         25      /* bans + exceptions together */
+#define MAXBANS         300     /* bans + exceptions together */
 #define MAXBANLENGTH    1024
 #define MAXSILES        50
 #define MAXSILELENGTH   128
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/include/numeric.h ircd-hybrid-6.0/include/numeric.h
--- ircd-hybrid-6.0.orig/include/numeric.h	Wed Jun 27 20:51:05 2001
+++ ircd-hybrid-6.0/include/numeric.h	Wed Jun 27 20:32:57 2001
@@ -132,6 +132,11 @@
 extern const char* form_str(int);
 
 /*
+ * and this one for strings without associated numerics
+ */
+extern const char* get_str(int);
+
+/*
  * Reserve numerics 000-099 for server-client connections where the client
  * is local to the server. If any server is passed a numeric in this range
  * from another server then it is remapped to 100-199. -avalon
@@ -376,5 +381,7 @@
 #define ERR_MAXFORWARDING    513
 
 #define ERR_BLOCKING_NOTID   505
+
+#define STR_BUGREPORT        001
 
 #endif /* INCLUDED_numeric_h */
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/blalloc.c ircd-hybrid-6.0/src/blalloc.c
--- ircd-hybrid-6.0.orig/src/blalloc.c	Wed Jun 27 20:51:06 2001
+++ ircd-hybrid-6.0/src/blalloc.c	Wed Jun 27 20:31:47 2001
@@ -10,6 +10,7 @@
 #include "ircd_defs.h"      /* DEBUG_BLOCK_ALLOCATOR */
 #include "irc_string.h"     /* MyMalloc */
 #include "s_log.h"
+#include "numeric.h"
 
 #include <string.h>
 #include <stdlib.h>
@@ -283,7 +284,7 @@
 			     bh->elemSize,
 			     BH_CurrentFile,
 			     BH_CurrentLine);
-      sendto_ops_flag(UMODE_DEBUG, "Please report to the dancer-hybrid team! opn-coders@vc.bc.ca");
+      sendto_ops_flag(UMODE_DEBUG, get_str(STR_BUGREPORT));
 #endif /* DEBUG_BLOCK_ALLOCATOR */
             }
           else
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_whois.c ircd-hybrid-6.0/src/m_whois.c
--- ircd-hybrid-6.0.orig/src/m_whois.c	Wed Jun 27 20:51:06 2001
+++ ircd-hybrid-6.0/src/m_whois.c	Wed Jun 27 20:29:18 2001
@@ -306,12 +306,12 @@
 	    {
 	      sendto_one(sptr, form_str(RPL_WHOISOPERATOR),
 			 me.name, parv[0], name);
-	      if (IsSetOperGod(acptr) || IsSetOperGline(acptr) || IsSetOperK(acptr) || IsSetOperGlobalKill(acptr))
-		sendto_one(sptr, form_str(RPL_WHOISOPER_GOD),
-			   me.name, parv[0], name);
-	      else
-		sendto_one(sptr, form_str(RPL_WHOISOPER_NOTGOD),
-			   me.name, parv[0], name);
+/* 	      if (IsSetOperGod(acptr) || IsSetOperGline(acptr) || IsSetOperK(acptr) || IsSetOperGlobalKill(acptr)) */
+/* 		sendto_one(sptr, form_str(RPL_WHOISOPER_GOD), */
+/* 			   me.name, parv[0], name); */
+/* 	      else */
+/* 		sendto_one(sptr, form_str(RPL_WHOISOPER_NOTGOD), */
+/* 			   me.name, parv[0], name); */
 	    }
 	  {
 	    umode_t umodes;
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/messages_cust.tab ircd-hybrid-6.0/src/messages_cust.tab
--- ircd-hybrid-6.0.orig/src/messages_cust.tab	Wed Jun 27 20:51:05 2001
+++ ircd-hybrid-6.0/src/messages_cust.tab	Wed Jun 27 20:37:00 2001
@@ -562,3 +562,517 @@
 };
 
 
+static char* strings[] = {
+/* 000 */       (char *)NULL,
+/* 001 STR_BUGREPORT*/       "Please report to the dancer-hybrid team! opn-coders@vc.bc.ca",
+/* 002 */       (char *)NULL,
+/* 003 */       (char *)NULL,
+/* 004 */       (char *)NULL,
+/* 005 */       (char *)NULL,
+/* 006 */       (char *)NULL,
+/* 007 */       (char *)NULL,
+/* 008 */       (char *)NULL,
+/* 009 */       (char *)NULL,
+/* 010 */       (char *)NULL,
+/* 011 */       (char *)NULL,
+/* 012 */       (char *)NULL,
+/* 013 */       (char *)NULL,
+/* 014 */       (char *)NULL,
+/* 015 */       (char *)NULL,
+/* 016 */       (char *)NULL,
+/* 017 */       (char *)NULL,
+/* 018 */       (char *)NULL,
+/* 019 */       (char *)NULL,
+/* 020 */       (char *)NULL,
+/* 021 */       (char *)NULL,
+/* 022 */       (char *)NULL,
+/* 023 */       (char *)NULL,
+/* 024 */       (char *)NULL,
+/* 025 */       (char *)NULL,
+/* 026 */       (char *)NULL,
+/* 027 */       (char *)NULL,
+/* 028 */       (char *)NULL,
+/* 029 */       (char *)NULL,
+/* 030 */       (char *)NULL,
+/* 031 */       (char *)NULL,
+/* 032 */       (char *)NULL,
+/* 033 */       (char *)NULL,
+/* 034 */       (char *)NULL,
+/* 035 */       (char *)NULL,
+/* 036 */       (char *)NULL,
+/* 037 */       (char *)NULL,
+/* 038 */       (char *)NULL,
+/* 039 */       (char *)NULL,
+/* 040 */       (char *)NULL,
+/* 041 */       (char *)NULL,
+/* 042 */       (char *)NULL,
+/* 043 */       (char *)NULL,
+/* 044 */       (char *)NULL,
+/* 045 */       (char *)NULL,
+/* 046 */       (char *)NULL,
+/* 047 */       (char *)NULL,
+/* 048 */       (char *)NULL,
+/* 049 */       (char *)NULL,
+/* 050 */       (char *)NULL,
+/* 051 */       (char *)NULL,
+/* 052 */       (char *)NULL,
+/* 053 */       (char *)NULL,
+/* 054 */       (char *)NULL,
+/* 055 */       (char *)NULL,
+/* 056 */       (char *)NULL,
+/* 057 */       (char *)NULL,
+/* 058 */       (char *)NULL,
+/* 059 */       (char *)NULL,
+/* 060 */       (char *)NULL,
+/* 061 */       (char *)NULL,
+/* 062 */       (char *)NULL,
+/* 063 */       (char *)NULL,
+/* 064 */       (char *)NULL,
+/* 065 */       (char *)NULL,
+/* 066 */       (char *)NULL,
+/* 067 */       (char *)NULL,
+/* 068 */       (char *)NULL,
+/* 069 */       (char *)NULL,
+/* 070 */       (char *)NULL,
+/* 071 */       (char *)NULL,
+/* 072 */       (char *)NULL,
+/* 073 */       (char *)NULL,
+/* 074 */       (char *)NULL,
+/* 075 */       (char *)NULL,
+/* 076 */       (char *)NULL,
+/* 077 */       (char *)NULL,
+/* 078 */       (char *)NULL,
+/* 079 */       (char *)NULL,
+/* 080 */       (char *)NULL,
+/* 081 */       (char *)NULL,
+/* 082 */       (char *)NULL,
+/* 083 */       (char *)NULL,
+/* 084 */       (char *)NULL,
+/* 085 */       (char *)NULL,
+/* 086 */       (char *)NULL,
+/* 087 */       (char *)NULL,
+/* 088 */       (char *)NULL,
+/* 089 */       (char *)NULL,
+/* 090 */       (char *)NULL,
+/* 091 */       (char *)NULL,
+/* 092 */       (char *)NULL,
+/* 093 */       (char *)NULL,
+/* 094 */       (char *)NULL,
+/* 095 */       (char *)NULL,
+/* 096 */       (char *)NULL,
+/* 097 */       (char *)NULL,
+/* 098 */       (char *)NULL,
+/* 099 */       (char *)NULL,
+/* 100 */       (char *)NULL,
+/* 101 */       (char *)NULL,
+/* 102 */       (char *)NULL,
+/* 103 */       (char *)NULL,
+/* 104 */       (char *)NULL,
+/* 105 */       (char *)NULL,
+/* 106 */       (char *)NULL,
+/* 107 */       (char *)NULL,
+/* 108 */       (char *)NULL,
+/* 109 */       (char *)NULL,
+/* 110 */       (char *)NULL,
+/* 111 */       (char *)NULL,
+/* 112 */       (char *)NULL,
+/* 113 */       (char *)NULL,
+/* 114 */       (char *)NULL,
+/* 115 */       (char *)NULL,
+/* 116 */       (char *)NULL,
+/* 117 */       (char *)NULL,
+/* 118 */       (char *)NULL,
+/* 119 */       (char *)NULL,
+/* 120 */       (char *)NULL,
+/* 121 */       (char *)NULL,
+/* 122 */       (char *)NULL,
+/* 123 */       (char *)NULL,
+/* 124 */       (char *)NULL,
+/* 125 */       (char *)NULL,
+/* 126 */       (char *)NULL,
+/* 127 */       (char *)NULL,
+/* 128 */       (char *)NULL,
+/* 129 */       (char *)NULL,
+/* 130 */       (char *)NULL,
+/* 131 */       (char *)NULL,
+/* 132 */       (char *)NULL,
+/* 133 */       (char *)NULL,
+/* 134 */       (char *)NULL,
+/* 135 */       (char *)NULL,
+/* 136 */       (char *)NULL,
+/* 137 */       (char *)NULL,
+/* 138 */       (char *)NULL,
+/* 139 */       (char *)NULL,
+/* 140 */       (char *)NULL,
+/* 141 */       (char *)NULL,
+/* 142 */       (char *)NULL,
+/* 143 */       (char *)NULL,
+/* 144 */       (char *)NULL,
+/* 145 */       (char *)NULL,
+/* 146 */       (char *)NULL,
+/* 147 */       (char *)NULL,
+/* 148 */       (char *)NULL,
+/* 149 */       (char *)NULL,
+/* 150 */       (char *)NULL,
+/* 151 */       (char *)NULL,
+/* 152 */       (char *)NULL,
+/* 153 */       (char *)NULL,
+/* 154 */       (char *)NULL,
+/* 155 */       (char *)NULL,
+/* 156 */       (char *)NULL,
+/* 157 */       (char *)NULL,
+/* 158 */       (char *)NULL,
+/* 159 */       (char *)NULL,
+/* 160 */       (char *)NULL,
+/* 161 */       (char *)NULL,
+/* 162 */       (char *)NULL,
+/* 163 */       (char *)NULL,
+/* 164 */       (char *)NULL,
+/* 165 */       (char *)NULL,
+/* 166 */       (char *)NULL,
+/* 167 */       (char *)NULL,
+/* 168 */       (char *)NULL,
+/* 169 */       (char *)NULL,
+/* 170 */       (char *)NULL,
+/* 171 */       (char *)NULL,
+/* 172 */       (char *)NULL,
+/* 173 */       (char *)NULL,
+/* 174 */       (char *)NULL,
+/* 175 */       (char *)NULL,
+/* 176 */       (char *)NULL,
+/* 177 */       (char *)NULL,
+/* 178 */       (char *)NULL,
+/* 179 */       (char *)NULL,
+/* 180 */       (char *)NULL,
+/* 181 */       (char *)NULL,
+/* 182 */       (char *)NULL,
+/* 183 */       (char *)NULL,
+/* 184 */       (char *)NULL,
+/* 185 */       (char *)NULL,
+/* 186 */       (char *)NULL,
+/* 187 */       (char *)NULL,
+/* 188 */       (char *)NULL,
+/* 189 */       (char *)NULL,
+/* 190 */       (char *)NULL,
+/* 191 */       (char *)NULL,
+/* 192 */       (char *)NULL,
+/* 193 */       (char *)NULL,
+/* 194 */       (char *)NULL,
+/* 195 */       (char *)NULL,
+/* 196 */       (char *)NULL,
+/* 197 */       (char *)NULL,
+/* 198 */       (char *)NULL,
+/* 199 */       (char *)NULL,
+/* 200 */       (char *)NULL,
+/* 201 */       (char *)NULL,
+/* 202 */       (char *)NULL,
+/* 203 */       (char *)NULL,
+/* 204 */       (char *)NULL,
+/* 205 */       (char *)NULL,
+/* 206 */       (char *)NULL,
+/* 207 */       (char *)NULL,
+/* 208 */       (char *)NULL,
+/* 209 */       (char *)NULL,
+/* 210 */       (char *)NULL,
+/* 211 */       (char *)NULL,
+/* 212 */       (char *)NULL,
+/* 213 */       (char *)NULL,
+/* 214 */       (char *)NULL,
+/* 215 */       (char *)NULL,
+/* 216 */       (char *)NULL,
+/* 217 */       (char *)NULL,
+/* 218 */       (char *)NULL,
+/* 219 */       (char *)NULL,
+/* 220 */       (char *)NULL,
+/* 221 */       (char *)NULL,
+/* 222 */       (char *)NULL,
+/* 223 */       (char *)NULL,
+/* 224 */       (char *)NULL,
+/* 225 */       (char *)NULL,
+/* 226 */       (char *)NULL,
+/* 227 */       (char *)NULL,
+/* 228 */       (char *)NULL,
+/* 229 */       (char *)NULL,
+/* 230 */       (char *)NULL,
+/* 231 */       (char *)NULL,
+/* 232 */       (char *)NULL,
+/* 233 */       (char *)NULL,
+/* 234 */       (char *)NULL,
+/* 235 */       (char *)NULL,
+/* 236 */       (char *)NULL,
+/* 237 */       (char *)NULL,
+/* 238 */       (char *)NULL,
+/* 239 */       (char *)NULL,
+/* 240 */       (char *)NULL,
+/* 241 */       (char *)NULL,
+/* 242 */       (char *)NULL,
+/* 243 */       (char *)NULL,
+/* 244 */       (char *)NULL,
+/* 245 */       (char *)NULL,
+/* 246 */       (char *)NULL,
+/* 247 */       (char *)NULL,
+/* 248 */       (char *)NULL,
+/* 249 */       (char *)NULL,
+/* 250 */       (char *)NULL,
+/* 251 */       (char *)NULL,
+/* 252 */       (char *)NULL,
+/* 253 */       (char *)NULL,
+/* 254 */       (char *)NULL,
+/* 255 */       (char *)NULL,
+/* 256 */       (char *)NULL,
+/* 257 */       (char *)NULL,
+/* 258 */       (char *)NULL,
+/* 259 */       (char *)NULL,
+/* 260 */       (char *)NULL,
+/* 261 */       (char *)NULL,
+/* 262 */       (char *)NULL,
+/* 263 */       (char *)NULL,
+/* 264 */       (char *)NULL,
+/* 265 */       (char *)NULL,
+/* 266 */       (char *)NULL,
+/* 267 */       (char *)NULL,
+/* 268 */       (char *)NULL,
+/* 269 */       (char *)NULL,
+/* 270 */       (char *)NULL,
+/* 271 */       (char *)NULL,
+/* 272 */       (char *)NULL,
+/* 273 */       (char *)NULL,
+/* 274 */       (char *)NULL,
+/* 275 */       (char *)NULL,
+/* 276 */       (char *)NULL,
+/* 277 */       (char *)NULL,
+/* 278 */       (char *)NULL,
+/* 279 */       (char *)NULL,
+/* 280 */       (char *)NULL,
+/* 281 */       (char *)NULL,
+/* 282 */       (char *)NULL,
+/* 283 */       (char *)NULL,
+/* 284 */       (char *)NULL,
+/* 285 */       (char *)NULL,
+/* 286 */       (char *)NULL,
+/* 287 */       (char *)NULL,
+/* 288 */       (char *)NULL,
+/* 289 */       (char *)NULL,
+/* 290 */       (char *)NULL,
+/* 291 */       (char *)NULL,
+/* 292 */       (char *)NULL,
+/* 293 */       (char *)NULL,
+/* 294 */       (char *)NULL,
+/* 295 */       (char *)NULL,
+/* 296 */       (char *)NULL,
+/* 297 */       (char *)NULL,
+/* 298 */       (char *)NULL,
+/* 299 */       (char *)NULL,
+/* 300 */       (char *)NULL,
+/* 301 */       (char *)NULL,
+/* 302 */       (char *)NULL,
+/* 303 */       (char *)NULL,
+/* 304 */       (char *)NULL,
+/* 305 */       (char *)NULL,
+/* 306 */       (char *)NULL,
+/* 307 */       (char *)NULL,
+/* 308 */       (char *)NULL,
+/* 309 */       (char *)NULL,
+/* 310 */       (char *)NULL,
+/* 311 */       (char *)NULL,
+/* 312 */       (char *)NULL,
+/* 313 */       (char *)NULL,
+/* 314 */       (char *)NULL,
+/* 315 */       (char *)NULL,
+/* 316 */       (char *)NULL,
+/* 317 */       (char *)NULL,
+/* 318 */       (char *)NULL,
+/* 319 */       (char *)NULL,
+/* 320 */       (char *)NULL,
+/* 321 */       (char *)NULL,
+/* 322 */       (char *)NULL,
+/* 323 */       (char *)NULL,
+/* 324 */       (char *)NULL,
+/* 325 */       (char *)NULL,
+/* 326 */       (char *)NULL,
+/* 327 */       (char *)NULL,
+/* 328 */       (char *)NULL,
+/* 329 */       (char *)NULL,
+/* 330 */       (char *)NULL,
+/* 331 */       (char *)NULL,
+/* 332 */       (char *)NULL,
+/* 333 */       (char *)NULL,
+/* 334 */       (char *)NULL,
+/* 335 */       (char *)NULL,
+/* 336 */       (char *)NULL,
+/* 337 */       (char *)NULL,
+/* 338 */       (char *)NULL,
+/* 339 */       (char *)NULL,
+/* 340 */       (char *)NULL,
+/* 341 */       (char *)NULL,
+/* 342 */       (char *)NULL,
+/* 343 */       (char *)NULL,
+/* 344 */       (char *)NULL,
+/* 345 */       (char *)NULL,
+/* 346 */       (char *)NULL,
+/* 347 */       (char *)NULL,
+/* 348 */       (char *)NULL,
+/* 349 */       (char *)NULL,
+/* 350 */       (char *)NULL,
+/* 351 */       (char *)NULL,
+/* 352 */       (char *)NULL,
+/* 353 */       (char *)NULL,
+/* 354 */       (char *)NULL,
+/* 355 */       (char *)NULL,
+/* 356 */       (char *)NULL,
+/* 357 */       (char *)NULL,
+/* 358 */       (char *)NULL,
+/* 359 */       (char *)NULL,
+/* 360 */       (char *)NULL,
+/* 361 */       (char *)NULL,
+/* 362 */       (char *)NULL,
+/* 363 */       (char *)NULL,
+/* 364 */       (char *)NULL,
+/* 365 */       (char *)NULL,
+/* 366 */       (char *)NULL,
+/* 367 */       (char *)NULL,
+/* 368 */       (char *)NULL,
+/* 369 */       (char *)NULL,
+/* 370 */       (char *)NULL,
+/* 371 */       (char *)NULL,
+/* 372 */       (char *)NULL,
+/* 373 */       (char *)NULL,
+/* 374 */       (char *)NULL,
+/* 375 */       (char *)NULL,
+/* 376 */       (char *)NULL,
+/* 377 */       (char *)NULL,
+/* 378 */       (char *)NULL,
+/* 379 */       (char *)NULL,
+/* 380 */       (char *)NULL,
+/* 381 */       (char *)NULL,
+/* 382 */       (char *)NULL,
+/* 383 */       (char *)NULL,
+/* 384 */       (char *)NULL,
+/* 385 */       (char *)NULL,
+/* 386 */       (char *)NULL,
+/* 387 */       (char *)NULL,
+/* 388 */       (char *)NULL,
+/* 389 */       (char *)NULL,
+/* 390 */       (char *)NULL,
+/* 391 */       (char *)NULL,
+/* 392 */       (char *)NULL,
+/* 393 */       (char *)NULL,
+/* 394 */       (char *)NULL,
+/* 395 */       (char *)NULL,
+/* 396 */       (char *)NULL,
+/* 397 */       (char *)NULL,
+/* 398 */       (char *)NULL,
+/* 399 */       (char *)NULL,
+/* 400 */       (char *)NULL,
+/* 401 */       (char *)NULL,
+/* 402 */       (char *)NULL,
+/* 403 */       (char *)NULL,
+/* 404 */       (char *)NULL,
+/* 405 */       (char *)NULL,
+/* 406 */       (char *)NULL,
+/* 407 */       (char *)NULL,
+/* 408 */       (char *)NULL,
+/* 409 */       (char *)NULL,
+/* 410 */       (char *)NULL,
+/* 411 */       (char *)NULL,
+/* 412 */       (char *)NULL,
+/* 413 */       (char *)NULL,
+/* 414 */       (char *)NULL,
+/* 415 */       (char *)NULL,
+/* 416 */       (char *)NULL,
+/* 417 */       (char *)NULL,
+/* 418 */       (char *)NULL,
+/* 419 */       (char *)NULL,
+/* 420 */       (char *)NULL,
+/* 421 */       (char *)NULL,
+/* 422 */       (char *)NULL,
+/* 423 */       (char *)NULL,
+/* 424 */       (char *)NULL,
+/* 425 */       (char *)NULL,
+/* 426 */       (char *)NULL,
+/* 427 */       (char *)NULL,
+/* 428 */       (char *)NULL,
+/* 429 */       (char *)NULL,
+/* 430 */       (char *)NULL,
+/* 431 */       (char *)NULL,
+/* 432 */       (char *)NULL,
+/* 433 */       (char *)NULL,
+/* 434 */       (char *)NULL,
+/* 435 */       (char *)NULL,
+/* 436 */       (char *)NULL,
+/* 437 */       (char *)NULL,
+/* 438 */       (char *)NULL,
+/* 439 */       (char *)NULL,
+/* 440 */       (char *)NULL,
+/* 441 */       (char *)NULL,
+/* 442 */       (char *)NULL,
+/* 443 */       (char *)NULL,
+/* 444 */       (char *)NULL,
+/* 445 */       (char *)NULL,
+/* 446 */       (char *)NULL,
+/* 447 */       (char *)NULL,
+/* 448 */       (char *)NULL,
+/* 449 */       (char *)NULL,
+/* 450 */       (char *)NULL,
+/* 451 */       (char *)NULL,
+/* 452 */       (char *)NULL,
+/* 453 */       (char *)NULL,
+/* 454 */       (char *)NULL,
+/* 455 */       (char *)NULL,
+/* 456 */       (char *)NULL,
+/* 457 */       (char *)NULL,
+/* 458 */       (char *)NULL,
+/* 459 */       (char *)NULL,
+/* 460 */       (char *)NULL,
+/* 461 */       (char *)NULL,
+/* 462 */       (char *)NULL,
+/* 463 */       (char *)NULL,
+/* 464 */       (char *)NULL,
+/* 465 */       (char *)NULL,
+/* 466 */       (char *)NULL,
+/* 467 */       (char *)NULL,
+/* 468 */       (char *)NULL,
+/* 469 */       (char *)NULL,
+/* 470 */       (char *)NULL,
+/* 471 */       (char *)NULL,
+/* 472 */       (char *)NULL,
+/* 473 */       (char *)NULL,
+/* 474 */       (char *)NULL,
+/* 475 */       (char *)NULL,
+/* 476 */       (char *)NULL,
+/* 477 */       (char *)NULL,
+/* 478 */       (char *)NULL,
+/* 479 */       (char *)NULL,
+/* 480 */       (char *)NULL,
+/* 481 */       (char *)NULL,
+/* 482 */       (char *)NULL,
+/* 483 */       (char *)NULL,
+/* 484 */       (char *)NULL,
+/* 485 */       (char *)NULL,
+/* 486 */       (char *)NULL,
+/* 487 */       (char *)NULL,
+/* 488 */       (char *)NULL,
+/* 489 */       (char *)NULL,
+/* 490 */       (char *)NULL,
+/* 491 */       (char *)NULL,
+/* 492 */       (char *)NULL,
+/* 493 */       (char *)NULL,
+/* 494 */       (char *)NULL,
+/* 495 */       (char *)NULL,
+/* 496 */       (char *)NULL,
+/* 497 */       (char *)NULL,
+/* 498 */       (char *)NULL,
+/* 499 */       (char *)NULL,
+/* 500 */       (char *)NULL,
+/* 501 */       (char *)NULL,
+/* 502 */       (char *)NULL,
+/* 503 */       (char *)NULL,
+/* 504 */       (char *)NULL,
+/* 505 */       (char *)NULL,
+/* 506 */       (char *)NULL,
+/* 507 */       (char *)NULL,
+/* 508 */       (char *)NULL,
+/* 509 */       (char *)NULL,
+/* 510 */       (char *)NULL,
+/* 511 */       (char *)NULL,
+};
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/numeric.c ircd-hybrid-6.0/src/numeric.c
--- ircd-hybrid-6.0.orig/src/numeric.c	Wed Jul 28 23:27:46 1999
+++ ircd-hybrid-6.0/src/numeric.c	Wed Jun 27 20:37:09 2001
@@ -75,4 +75,12 @@
 #endif
 }
 
+const char* get_str(int numeric)
+{
 
+  assert(-1 < numeric);
+  assert(numeric < ERR_LAST_ERR_MSG);
+  assert(0 != strings[numeric]);
+
+  return strings[numeric];
+}