diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/include/config.h ircd-hybrid-6.0/include/config.h
--- ircd-hybrid-6.0.orig/include/config.h	Thu Jun 28 20:40:16 2001
+++ ircd-hybrid-6.0/include/config.h	Thu Jun 28 20:39:47 2001
@@ -452,7 +452,7 @@
 /* PACE_WAIT - minimum seconds between use of MOTD, INFO, HELP, LINKS, TRACE
  * -Dianora
  */
-#define PACE_WAIT 5
+#define PACE_WAIT 3
 
 /* KNOCK_DELAY 5 minutes per each KNOCK should be enough
  */
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/include/patchlevel.h ircd-hybrid-6.0/include/patchlevel.h
--- ircd-hybrid-6.0.orig/include/patchlevel.h	Thu Jun 28 20:40:16 2001
+++ ircd-hybrid-6.0/include/patchlevel.h	Thu Jun 28 20:39:58 2001
@@ -17,5 +17,5 @@
  */
 
 #ifndef PATCHLEVEL
-#define PATCHLEVEL    "dancer-ircd-0.9.2.1"
+#define PATCHLEVEL    "dancer-ircd-0.9.3.1"
 #endif
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/include/send.h ircd-hybrid-6.0/include/send.h
--- ircd-hybrid-6.0.orig/include/send.h	Thu Jun 28 20:40:16 2001
+++ ircd-hybrid-6.0/include/send.h	Thu Jun 28 20:39:47 2001
@@ -72,8 +72,10 @@
 
 extern  void sendto_ops_flag(int, const char *, ...);
 extern  void sendto_ops_flag_butone(struct Client *, int, const char *, ...);
-extern  void sendto_ops_flag_butone_from(struct Client *, int, struct Client*, const char *, ...);
-extern  void sendto_ops_flag_butone_hidefrom(struct Client *, int, const char *, ...);
+extern  void sendto_ops_flag_butflag(int, int, const char *, ...);
+extern  void sendto_ops_flag_butflag_butone(struct Client *, int, int, const char *, ...);
+extern  void sendto_ops_flag_butflag_butone_from(struct Client *, int, int, struct Client*, const char *, ...);
+extern  void sendto_ops_flag_butflag_butone_hidefrom(struct Client *, int, int, const char *, ...);
 extern  void sendto_local_ops_flag(int, const char*, ...);
 extern  void sendto_local_ops_flag_butone(struct Client *, int, const char *, ...);
 extern  void sendto_local_ops_flag_butone_from(struct Client *, int, struct Client*, const char *, ...);
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/Makefile.in ircd-hybrid-6.0/src/Makefile.in
--- ircd-hybrid-6.0.orig/src/Makefile.in	Thu Jun 28 20:40:15 2001
+++ ircd-hybrid-6.0/src/Makefile.in	Thu Jun 28 20:39:47 2001
@@ -14,7 +14,7 @@
  
 #
 # For developers
-CFLAGS= -g -O2 -Wall -W -Werror -Wcast-qual -pedantic -Wno-unused
+CFLAGS= -g3 -O0 -Wall -W -Werror -Wcast-qual -pedantic -Wno-unused
 #
 
 SRCS = \
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/client.c ircd-hybrid-6.0/src/client.c
--- ircd-hybrid-6.0.orig/src/client.c	Thu Jun 28 20:40:16 2001
+++ ircd-hybrid-6.0/src/client.c	Thu Jun 28 20:39:47 2001
@@ -1605,9 +1605,9 @@
 
       if (sptr->servptr == &me)
         {
-          sendto_ops_flag(UMODE_SERVNOTICE, "%s was connected to %s for %d seconds.  %d/%d sendK/recvK.",
-				 sptr->name, &me.name, CurrentTime - sptr->firsttime,
-				 sptr->sendK, sptr->receiveK);
+          sendto_ops_flag(UMODE_SEEROUTING, "%s was connected to %s for %d seconds.  %d/%d sendK/recvK.",
+			  sptr->name, &me.name, CurrentTime - sptr->firsttime,
+			  sptr->sendK, sptr->receiveK);
           log(L_NOTICE, "%s was connected for %d seconds.  %d/%d sendK/recvK.",
               sptr->name, CurrentTime - sptr->firsttime, 
               sptr->sendK, sptr->receiveK);
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_away.c ircd-hybrid-6.0/src/m_away.c
--- ircd-hybrid-6.0.orig/src/m_away.c	Thu Jun 28 20:40:15 2001
+++ ircd-hybrid-6.0/src/m_away.c	Thu Jun 28 20:39:47 2001
@@ -31,6 +31,7 @@
 
 #include <stdlib.h>
 #include <string.h>
+#include <ctype.h>
 
 /*
  * m_functions execute protocol messages on this server:
@@ -117,7 +118,7 @@
   if (!(sptr->user))
     {
       sendto_ops_flag(UMODE_DEBUG,
-			     "Got AWAY from nil user, from %s (%s)\n",cptr->name,sptr->name);
+		      "Got AWAY from nil user, from %s (%s)\n",cptr->name,sptr->name);
       return 0;
     }
 
@@ -151,6 +152,33 @@
   
   if (strlen(awy2) > (size_t) TOPICLEN)
     awy2[TOPICLEN] = '\0';
+
+  /* Strip colour and other junk from the string */
+  {
+    int i;
+    char* new_away = awy2;
+    for(i = 0; (i < TOPICLEN) && awy2[i]; i++)
+      switch (awy2[i])
+	{
+	case 3:
+	  i++; /* skip the next character, since it's known junk */
+	  if (isdigit(awy2[i+1])) /* if the one after is a number, it's junk too */
+	    i++;
+	  break;
+	case 2: /* bold... */
+	case 18: /* ...reverse video... */
+	case 21: /* ...and underline */
+	  break;
+	case 0:
+	  i = TOPICLEN;
+	  break;
+	default:
+	  *new_away++ = awy2[i];
+	  break;
+	}
+    *new_away = '\0';
+  }
+
 /* some lamers scripts continually do a /away, hence making a lot of
    unnecessary traffic. *sigh* so... as comstud has done, I've
    commented out this sendto_serv_butone() call -Dianora */
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_kill.c ircd-hybrid-6.0/src/m_kill.c
--- ircd-hybrid-6.0.orig/src/m_kill.c	Thu Jun 28 20:40:15 2001
+++ ircd-hybrid-6.0/src/m_kill.c	Thu Jun 28 20:39:47 2001
@@ -180,8 +180,8 @@
       inpath = cptr->host;
       if (!BadPtr(path))
         {
-          ircsprintf(buf, "%s!%s (%s)",
-                     cptr->username, cptr->name,
+          ircsprintf(buf, "%s (%s)",
+                     cptr->name,
                      path);
           path = buf;
           reason = path;
@@ -222,8 +222,9 @@
 
   if (!IsServer(sptr)) /* send it normally */
     {
-      sendto_ops_flag(UMODE_SKILL, "Received KILL message for %s. From %s Path: %s!%s", 
-               acptr->name, parv[0], inpath, path);
+      if (MyClient(acptr))
+	sendto_ops_flag(UMODE_SKILL, "Received KILL message for %s. From %s Path: %s!%s", 
+			acptr->name, parv[0], inpath, path);
       /*
        * dilema here: we don't want non opers to see pathes which
        * contain real IP addresses.  But we do want opers to see them.
@@ -235,9 +236,10 @@
        */
     }
   else
-    sendto_ops_flag(UMODE_SKILL,
-			"Received KILL message for %s. From %s",
-			acptr->name, parv[0]);
+    if (MyClient(acptr))
+      sendto_ops_flag(UMODE_SKILL,
+		      "Received KILL message for %s. From %s",
+		      acptr->name, parv[0]);
 
 #if defined(USE_SYSLOG) && defined(SYSLOG_KILL)
   if (!IsServer(sptr))
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_message.c ircd-hybrid-6.0/src/m_message.c
--- ircd-hybrid-6.0.orig/src/m_message.c	Thu Jun 28 20:40:15 2001
+++ ircd-hybrid-6.0/src/m_message.c	Thu Jun 28 20:39:47 2001
@@ -38,7 +38,7 @@
 #include "s_user.h"
 
 #include <string.h>
-
+#include <ctype.h>
 
 /*
  * m_functions execute protocol messages on this server:
@@ -206,12 +206,34 @@
        * - Andre Guibert de Bruet <webdev@cheetah.properkernel.com>
        */
       if(chptr->mode.mode & MODE_NOCOLOR)
-        if(strchr(parv[2], 3) && !IsSetOperGod(sptr))
-          { 
-            sendto_one(sptr, form_str(ERR_NOCOLORSTOCHAN),
-                       me.name, parv[0], nick);
-            return 0;
-          }
+	{
+	  char *c = parv[2];
+	  char *c2 = parv[2];
+	  /* c is source, c2 is target */
+	  for (; c && *c; c++)
+	    switch(*c)
+	      {
+	      case 3:
+		if (isdigit(c[1]))
+		  {
+		    c++;
+		    if (isdigit(c[1]))
+		      c++;
+		    if (c[1] == ','&& isdigit(c[2]))
+		      {
+			c+=2;
+			if (isdigit(c[1]))
+			  c++;
+		      }
+		  }
+		break;
+	      case 2: case 22: case 31:
+		break;
+	      default:
+		*c2++ = *c;
+	      }
+	  *c2 = '\0';
+	}
 #endif /* NOCOLOUR_MODE */
 
       if (can_send(sptr, chptr) == 0)
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_pong.c ircd-hybrid-6.0/src/m_pong.c
--- ircd-hybrid-6.0.orig/src/m_pong.c	Thu Jun 28 20:40:14 2001
+++ ircd-hybrid-6.0/src/m_pong.c	Thu Jun 28 20:39:47 2001
@@ -124,8 +124,8 @@
       if (!got_server_pong)
         {
           sendto_ops_flag_butone(cptr, UMODE_SEEROUTING, "%s acknowledged end of %s burst (%i sec)",
-				 sptr->name, &me.name, CurrentTime - sptr->firsttime);
-	  sendto_ops_flag_butone_hidefrom(cptr, UMODE_SERVNOTICE, "Burst complete, %s has linked", sptr->name);
+					 sptr->name, &me.name, CurrentTime - sptr->firsttime);
+	  sendto_ops_flag_butflag_butone_hidefrom(cptr, UMODE_SERVNOTICE, UMODE_SEEROUTING, "Burst complete, %s has linked", sptr->name);
         }
       got_server_pong = 1;
     }
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_wallops.c ircd-hybrid-6.0/src/m_wallops.c
--- ircd-hybrid-6.0.orig/src/m_wallops.c	Thu Jun 28 20:40:14 2001
+++ ircd-hybrid-6.0/src/m_wallops.c	Thu Jun 28 20:39:47 2001
@@ -23,6 +23,7 @@
  *   $Id: 161-50-misc.patch,v 1.2 2001/07/16 18:55:39 lilo dead $
  */
 #include <stdlib.h>
+#include <string.h>
 #include "m_commands.h"
 #include "client.h"
 #include "ircd.h"
@@ -98,7 +99,7 @@
 int m_wallops(struct Client *cptr, struct Client *sptr, int parc, char *parv[])
 { 
   char* message;
-  int flag=0;
+  int flag=0, butflag=0;
   int spoof = 0;
 
   if (parc == 3)
@@ -109,6 +110,11 @@
 	  spoof = 1;
 	}
       flag = atoi(parv[1]);
+      {
+	char* but = strchr(parv[1], '-');
+	if (but)
+	  butflag = atoi(but + 1);
+      }
       message = parv[2];
     }
   else
@@ -136,9 +142,9 @@
   if (parc == 3)
     {
       if (spoof)
-	sendto_ops_flag_butone_hidefrom(cptr, flag, "%s", message);
+	sendto_ops_flag_butflag_butone_hidefrom(cptr, flag, butflag, "%s", message);
       else
-	sendto_ops_flag_butone_from(cptr, flag, sptr, "%s", message);
+	sendto_ops_flag_butflag_butone_from(cptr, flag, butflag, sptr, "%s", message);
       return 0;
     }
 
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/s_bsd.c ircd-hybrid-6.0/src/s_bsd.c
--- ircd-hybrid-6.0.orig/src/s_bsd.c	Thu Jun 28 20:40:15 2001
+++ ircd-hybrid-6.0/src/s_bsd.c	Thu Jun 28 20:39:47 2001
@@ -922,12 +922,12 @@
       int connected = CurrentTime - cptr->firsttime;
       
       if (0 == error)
-        sendto_ops_flag(UMODE_SERVNOTICE, "Server %s closed the connection",
+        sendto_ops_flag_butflag_butone_hidefrom(NULL, UMODE_SERVNOTICE, 0, "Server %s closed the connection",
 			       get_client_name(cptr, MASK_IP));
       else
         report_error("Lost connection to %s:%s", 
                      get_client_name(cptr, MASK_IP), current_error);
-      sendto_ops_flag(UMODE_SERVNOTICE,"%s had been connected for %d day%s, %2d:%02d:%02d",
+      sendto_ops_flag_butflag_butone_hidefrom(NULL, UMODE_SERVNOTICE, 0, "%s had been connected for %d day%s, %2d:%02d:%02d",
 			     cptr->name, connected/86400,
 			     (connected/86400 == 1) ? "" : "s",
 			     (connected % 86400) / 3600, (connected % 3600) / 60,
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/s_cr.c ircd-hybrid-6.0/src/s_cr.c
--- ircd-hybrid-6.0.orig/src/s_cr.c	Thu Jun 28 20:40:15 2001
+++ ircd-hybrid-6.0/src/s_cr.c	Thu Jun 28 20:39:47 2001
@@ -34,7 +34,7 @@
   strncpy_irc(cptr->name, n_conf->name, HOSTLEN);
   strcpy(cptr->passwd, chall);
   SetChallenged(cptr);
-  sendto_ops_flag(UMODE_DEBUG, "Sent password challenge to %s", cptr->name);
+  sendto_ops_flag(UMODE_EXTERNAL, "Sent password challenge to %s", cptr->name);
 }
 
 void cr_hashstring(char * src, char * trg) {
@@ -57,7 +57,7 @@
   cr_hashstring(work, hash);
   sendto_one(cptr, "RESP %s", hash);
   SetResponded(cptr);
-  sendto_ops_flag(UMODE_DEBUG, "Sent password response to %s", cptr->name);
+  sendto_ops_flag(UMODE_EXTERNAL, "Sent password response to %s", cptr->name);
 }
 
 void cr_gotresponse(struct Client * cptr, char * resp) {
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/s_serv.c ircd-hybrid-6.0/src/s_serv.c
--- ircd-hybrid-6.0.orig/src/s_serv.c	Thu Jun 28 20:40:16 2001
+++ ircd-hybrid-6.0/src/s_serv.c	Thu Jun 28 20:39:47 2001
@@ -740,7 +740,7 @@
   /* ircd-hybrid-6 can do TS links, and  zipped links*/
   sendto_ops_flag_butone(cptr, UMODE_SEEROUTING, "Link with %s established: %s",
 		  inpath,show_capabilities(cptr));
-  sendto_ops_flag_butone_hidefrom(cptr, UMODE_SERVNOTICE, "%s is linking to the network", cptr->name);
+  sendto_ops_flag_butflag_butone_hidefrom(cptr, UMODE_SERVNOTICE, UMODE_SEEROUTING, "%s is linking to the network", cptr->name);
   log(L_NOTICE, "Link with %s established: (%s) link",
              inpath_ip,show_capabilities(cptr));
 
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/s_user.c ircd-hybrid-6.0/src/s_user.c
--- ircd-hybrid-6.0.orig/src/s_user.c	Thu Jun 28 20:40:16 2001
+++ ircd-hybrid-6.0/src/s_user.c	Thu Jun 28 20:39:47 2001
@@ -1186,7 +1186,7 @@
           sptr->last_nick_change = CurrentTime;
             sptr->number_of_nick_changes++;
 
-          if(sptr->number_of_nick_changes <= MAX_NICK_CHANGES)
+          if((sptr->number_of_nick_changes <= MAX_NICK_CHANGES) || NoFloodProtection(sptr))
             {
 #endif
               sendto_ops_flag(UMODE_NCHANGE,
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/send.c ircd-hybrid-6.0/src/send.c
--- ircd-hybrid-6.0.orig/src/send.c	Thu Jun 28 20:40:16 2001
+++ ircd-hybrid-6.0/src/send.c	Thu Jun 28 20:39:47 2001
@@ -52,9 +52,9 @@
 
 static  void vsendto_prefix_one(register aClient *, register aClient *, const char *, va_list);
 static  void vsendto_one(aClient *, const char *, va_list);
-static  void vsendto_ops_flag_butone_from(aClient*, int, aClient*, const char *, va_list);
-static  void vsendto_local_ops_flag_butone_from(aClient*, int, aClient*, const char *, va_list);
-static  void vsendto_remote_ops_flag_butone_from(aClient*, int, aClient*, const char *, va_list);
+static  void vsendto_ops_flag_butflag_butone_from(aClient*, int, int, aClient*, const char *, va_list);
+static  void vsendto_local_ops_flag_butflag_butone_from(aClient*, int, int, aClient*, const char *, va_list);
+static  void vsendto_remote_ops_flag_butflag_butone_from(aClient*, int, int, aClient*, const char *, va_list);
 
 static  unsigned long sentalong[MAXCONNECTIONS];
 static unsigned long current_serial=0L;
@@ -1219,7 +1219,7 @@
       warnings = 0;
     }
 
-  vsendto_ops_flag_butone_from(NULL, UMODE_SERVNOTICE, &me, pattern, args);
+  vsendto_ops_flag_butflag_butone_from(NULL, UMODE_SERVNOTICE, 0, &me, pattern, args);
   vsprintf(buf, pattern, args);
   log(L_CRIT, "%s", buf);
 
@@ -1306,7 +1306,7 @@
 
   va_start(args, pattern);
 
-  vsendto_ops_flag_butone_from(NULL, flag, &me, pattern, args);
+  vsendto_ops_flag_butflag_butone_from(NULL, flag, 0, &me, pattern, args);
 
   va_end(args);
 }
@@ -1319,7 +1319,31 @@
 
   va_start(args, pattern);
 
-  vsendto_ops_flag_butone_from(one, flag, &me, pattern, args);
+  vsendto_ops_flag_butflag_butone_from(one, flag, 0, &me, pattern, args);
+
+  va_end(args);
+}
+
+void
+sendto_ops_flag_butflag(int flag, int butflag, const char* pattern, ...)
+{
+  va_list args;
+
+  va_start(args, pattern);
+
+  vsendto_ops_flag_butflag_butone_from(NULL, flag, butflag, &me, pattern, args);
+
+  va_end(args);
+}
+
+void
+sendto_ops_flag_butflag_butone(aClient* one, int flag, int butflag, const char* pattern, ...)
+{
+  va_list args;
+
+  va_start(args, pattern);
+
+  vsendto_ops_flag_butflag_butone_from(one, flag, butflag, &me, pattern, args);
 
   va_end(args);
 }
@@ -1330,21 +1354,21 @@
 */
 
 static void
-vsendto_ops_flag_butone_from(aClient *one, int flag, aClient* from, const char *pattern, va_list args)
+vsendto_ops_flag_butflag_butone_from(aClient *one, int flag, int butflag, aClient* from, const char *pattern, va_list args)
 {
-  vsendto_local_ops_flag_butone_from(one, flag, from, pattern, args);
-  vsendto_remote_ops_flag_butone_from(one, flag, from, pattern, args);
+  vsendto_local_ops_flag_butflag_butone_from(one, flag, butflag, from, pattern, args);
+  vsendto_remote_ops_flag_butflag_butone_from(one, flag, butflag, from, pattern, args);
 }
 
 static void
-vsendto_local_ops_flag_butone_from(aClient *one, int flag, aClient* from, const char *pattern, va_list args)
+vsendto_local_ops_flag_butflag_butone_from(aClient *one, int flag, int butflag, aClient* from, const char *pattern, va_list args)
 {
   register aClient *cptr;
   char nbuf[1024];
 
   for(cptr = local_cptr_list; cptr; cptr = cptr->next_local_client)
     {
-      if (IsPerson(cptr) && TestBit(cptr->umodes,flag))
+      if (IsPerson(cptr) && (!flag || TestBit(cptr->umodes,flag)) && (!butflag || !TestBit(cptr->umodes, butflag)))
 	{
 	  (void)ircsprintf(nbuf, ":%s NOTICE %s :*** Notice -- ",
 			   from->name, cptr->name);
@@ -1355,13 +1379,13 @@
 }
 
 static void
-vsendto_remote_ops_flag_butone_from(aClient *one, int flag, aClient* from, const char *pattern, va_list args)
+vsendto_remote_ops_flag_butflag_butone_from(aClient *one, int flag, int butflag, aClient* from, const char *pattern, va_list args)
 {
   register aClient *cptr;
   char nbuf[1024];
 
-  (void)ircsprintf(nbuf, ":%s WALLOPS %i :",
-		   from->name, flag);
+  (void)ircsprintf(nbuf, ":%s WALLOPS %i-%i :",
+		   from->name, flag, butflag);
   (void)strncat(nbuf, pattern, sizeof(nbuf) - strlen(nbuf));
   for(cptr = serv_cptr_list; cptr; cptr = cptr->next_server_client)
     {
@@ -1375,13 +1399,13 @@
 /* This one is used in the magic WALLOPS hack to propogate server notices */
 
 void
-sendto_ops_flag_butone_from(aClient *one, int flag, aClient* from, const char *pattern, ...)
+sendto_ops_flag_butflag_butone_from(aClient *one, int flag, int butflag, aClient* from, const char *pattern, ...)
 {
   va_list args;
 
   va_start(args, pattern);
 
-  vsendto_ops_flag_butone_from(one, flag, from, pattern, args);
+  vsendto_ops_flag_butflag_butone_from(one, flag, butflag, from, pattern, args);
 
   va_end(args);
 }
@@ -1389,7 +1413,7 @@
 /* This one is used to propogate without giving away the source (so protecting routing information) */
 
 void
-sendto_ops_flag_butone_hidefrom(aClient *one, int flag, const char *pattern, ...)
+sendto_ops_flag_butflag_butone_hidefrom(aClient *one, int flag, int butflag, const char *pattern, ...)
 {
   register aClient *cptr;
   char nbuf[1024];
@@ -1397,10 +1421,10 @@
 
   va_start(args, pattern);
 
-  vsendto_local_ops_flag_butone_from(one, flag, &me, pattern, args);
+  vsendto_local_ops_flag_butflag_butone_from(one, flag, butflag, &me, pattern, args);
 
-  (void)ircsprintf(nbuf, ":%s WALLOPS *%i :",
-		   me.name, flag);
+  (void)ircsprintf(nbuf, ":%s WALLOPS *%i-%i :",
+		   me.name, flag, butflag);
   (void)strncat(nbuf, pattern, sizeof(nbuf) - strlen(nbuf));
   for(cptr = serv_cptr_list; cptr; cptr = cptr->next_server_client)
     {
@@ -1419,7 +1443,7 @@
 
   va_start(args, pattern);
 
-  vsendto_local_ops_flag_butone_from(NULL, flag, &me, pattern, args);
+  vsendto_local_ops_flag_butflag_butone_from(NULL, flag, 0, &me, pattern, args);
 
   va_end(args);
 }
@@ -1431,7 +1455,7 @@
 
   va_start(args, pattern);
 
-  vsendto_local_ops_flag_butone_from(one, flag, &me, pattern, args);
+  vsendto_local_ops_flag_butflag_butone_from(one, flag, 0, &me, pattern, args);
 
   va_end(args);
 }
@@ -1443,7 +1467,7 @@
 
   va_start(args, pattern);
 
-  vsendto_local_ops_flag_butone_from(one, flag, from, pattern, args);
+  vsendto_local_ops_flag_butflag_butone_from(one, flag, 0, from, pattern, args);
 
   va_end(args);
 }